//
//  Curve.m
//  GHMMCurveRecognition
//
//  Created by Marcelo Cicconet on 10/20/11.
//  Copyright 2011 Georgia Tech. All rights reserved.
//

#import "Curve.h"

@implementation Curve

@synthesize xPoints, yPoints, numOfPoints;

- (id)initWithNumOfPoints:(int)theNumOfPoints xPoints:(float *)theXPoints yPoints:(float *)theYPoints reverseOrder:(BOOL)reverseOrder
{
    self = [super init];
    if (self) {
        numOfPoints = theNumOfPoints;
        xPoints = (float *)malloc(numOfPoints*sizeof(float));
        yPoints = (float *)malloc(numOfPoints*sizeof(float));
        if (reverseOrder) {
            for (int i = 0; i < numOfPoints; i++) {
                xPoints[numOfPoints-1-i] = theXPoints[i];
                yPoints[numOfPoints-1-i] = theYPoints[i];
            }
        } else {
            for (int i = 0; i < numOfPoints; i++) {
                xPoints[i] = theXPoints[i];
                yPoints[i] = theYPoints[i];
            }
        }
//        for (int i = 0; i < numOfPoints; i++) {
//            printf("%d: %f, %f\n", i, xPoints[i], yPoints[i]);
//        }
//        printf("\n");
    }
    
    return self;
}

- (void)dealloc {
    free(xPoints);
    free(yPoints);
    [super dealloc];
}

@end
