//
//  ModelGHMM.h
//  GHMMCurveRecognition
//
//  Created by Marcelo Cicconet on 10/21/11.
//  Copyright 2011 Georgia Tech. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "ghmm.h"
#import <stdio.h>
#import <unistd.h>
#import "matrix.h"
#import "rng.h"
#import "smodel.h"
#import "sfoba.h"
#import "matrixop.h"
#import "ghmm_internals.h"
#import "obsolete.h"

#import "Curve.h"

@interface ModelGHMM : NSObject {
    int dimension;
    double *c;
    double *u;
    double *inv_u;
    double *chd_u;
    ghmm_density_t density;

    int n_states;
    ghmm_c_emission * emissions;
    double ** mu;
    int M;
    int ** trans_ids_out;
    int ** trans_ids_in;
    ghmm_cstate * states;

    double ** alpha;
    double * scale;
    double log_p;
    int length;
    
    double * trans_prob_out_stencil_i;
    double * trans_prob_out_stencil_Nm2;
    double * trans_prob_out_stencil_Nm1;
    double * trans_prob_in_stencil_0;
    double * trans_prob_in_stencil_1;
    double * trans_prob_in_stencil_i;
    double * trans_prob_in_stencil_Nm1;
}

@property(readonly) int n_states;
@property(readonly, assign) ghmm_cstate * states;

- (id)initWithCurve:(Curve *)theCurve;

@end
