//
//  ObjGHMM.h
//  GHMMCurveRecognition
//
//  Created by Marcelo Cicconet on 10/21/11.
//  Copyright 2011 Georgia Tech. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "ghmm.h"
#import <stdio.h>
#import <unistd.h>
#import "matrix.h"
#import "rng.h"
#import "smodel.h"
#import "sfoba.h"
#import "matrixop.h"
#import "ghmm_internals.h"
#import "obsolete.h"

#import "Curve.h"
#import "ModelGHMM.h"

@interface ObjGHMM : NSObject {
    int nCurves;
    ghmm_cmodel * models;
    NSMutableArray * arrayOfModels;
    int ** maxStates;
    float ** likMaxStates;
    float * distanceToCurves;
    float * distanceToCurvesUsingAlpha;
    int * nCurvePoints;
}

@property(readonly, assign) float * distanceToCurves;
@property(readonly, assign) float * distanceToCurvesUsingAlpha;
@property(readonly, assign) int ** maxStates;
@property(readonly, assign) float ** likMaxStates;

- (void)trainWithCurves:(NSMutableArray *)theCurves;
- (void)testWithCurve:(Curve *)theCurve;

@end
